
local key = "Ваш Ключ"
local city = "Moscow"
-- Таблица с рабочими данными
if not dat then dat = {} end
-- Разные переменные
local tnow, sky, max, min, codenow, codef
-- Стринг полученного ответа от сервера
local answer = ''
local conn

-- Функция обработки полученного запроса
local function getdata()
	-- Закрываем и уничтожаем соединение
	conn:close()
	conn = nil
	-- Нет ответа - не повезло
	if answer == "" then 
		print('Lost answer!')
	else
		-- Захватываем из ответа (1) текущую температуру, (2) код текущей погоды,
		-- (3) максимальную темрературу сегодня, (4) минимальную температуру сегодня, 
		-- (5) код ожидаемой погоды 
		tnow, codenow, max, min, codef =  string.match(answer,'temp_c":(%p*%d+.%d*),.+"code":(%d+).+maxtemp_c":(%p*%d+).+mintemp_c":(%p*%d+).+"code":(%d+)')
		answer = nil
		-- Если что-то не получилось захватить - делаем значения по умолчанию.
		tnow = tnow or '- 50'
		max = max or '-50'
		min = min or '-50'
		codenow = tonumber(codenow) or 1000 
		codef = tonumber(codef) or 1000
		-- Заносим в рабочую таблицу данные 
		dat.asktemp = tnow..'0'
		print('Got Temp: '..dat.asktemp)
		dat.maxtemp = max
		dat.mintemp = min
		print('Got Max: '.. dat.maxtemp..', Min: '..dat.mintemp)
		dat.codenow = codenow
		dat.codef = codef
		print('Got Sky codes: '..dat.codenow..' '..dat.codef)
	end
	-- Зачищаем хвосты
	answer = nil
	tnow, sky, max, min, key, city, codenow, codef, getdata = nil, nil, nil, nil, nil, nil, nil, nil, nil
	dat.askw = 0
end

-- Готовим текст запроса к серверу
local request = "GET http://api.apixu.com/v1/forecast.json?key="..key.."&q="..city.." HTTP/1.1\r\n"..
	"Host: api.apixu.com\r\n\r\n"
-- Определяем соединение 
conn=net.createConnection(net.TCP, 0) 
-- Реакция на соединение - отправляем запрос
conn:on("connection", function(conn, payload) conn:send(request); request = nil end)

-- Реакция на получение данных
conn:on("receive", function(conn, payload)
	-- Данные приходят от сервера кадрами, если первый кадр - 
	-- пишем его в переменную answer
	if answer == '' then
		answer = payload
	-- на втором кадре -  добавляем к переменной answer,закрываем соединение
	-- и отправляем ответ в обработку.	
	else
		answer = answer .. payload
		payload = nil
		getdata()
	end
end) 
-- Приступаем к соединению и зспросу.
conn:connect(80, 'api.apixu.com')
